#include "ki/arc.h"
#include "ki/warc.h"
#include "ki/memory.h"

WeakARC* WeakARCNew(ARC *arc) {
  WeakARC *warc = ki_malloc(sizeof(WeakARC));

  WeakARCInit(warc, arc);

  return warc;
}

void WeakARCInit(WeakARC *warc, ARC *arc) {
  warc->arc = arc;
}

ARC* WeakARCGetARC(WeakARC *warc) {
  ARC *arc = NULL;

  (void)pthread_mutex_lock(&warc->arc->lock);
  if (warc->arc->refcount) {
    ARCIncrement(warc->arc);
    arc = warc->arc;
  }
  (void)pthread_mutex_unlock(&warc->arc->lock);

  return arc;
}


#endif

/* vi: set et ts=2 sw=2: */

